function hidePrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function showPrefs() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToBack");

    front.style.display="none";
    back.style.display="block";

    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

var gDoneButton;
var gInfoButton;

function setup() {
    gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Done", hidePrefs);
    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "white", "white", showPrefs);
}


function infendoSetup() {
   getRSS();
   setup();
widget.onshow = activate;
//widget.onshow = getRSS();
}

function activate () {
  setTimeout("getRSS()", 0);
}

function getRSS() {
  document.getElementById("status").innerHTML = "In getRSS...";

        try {
          netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
        }
        catch (e) {
          // this isn't netscape...
        }
        
  try  {
                                    
    var rssObj = new XMLHttpRequest();
    time = new Date();
    rssObj.open("GET", "http://feeds.feedburner.com/infendo", true);
    rssObj.overrideMimeType("text/xml");
    rssObj.onreadystatechange = function() {
      if (rssObj.readyState == 4) {
        if (rssObj.status == 200) {    
          document.getElementById("status").innerHTML = "Grabbing Data...";
          rssXML = rssObj.responseXML;
          
          document.getElementById("status").innerHTML = "Parsing Data...";
          parseRSS(rssXML);
          
          if (chkConn) { 
            clearInterval(chkConn); 
          }
        } 
        else {
          var chkConn;
          document.getElementById("status").innerText = "Click to retry";

        }
      } 
      else {
        document.getElementById("status").innerHTML = document.getElementById("status").innerHTML.toString() + ".";
      }
    }       
    rssObj.send(null);
    //rssObj.onreadystatechange = null;
  }
  catch(e) {
    document.getElementById("status").innerHTML = "ERROR";
  }
  document.getElementById("status").innerHTML = "finished";
}

function Mid(str, start, len)
        /***
                IN: str - the string we are LEFTing
                    start - our string's starting position (0 based!!)
                    len - how many characters from start we want to get

                RETVAL: The substring from start to start+len
        ***/
        {
                // Make sure start and len are within proper bounds
                if (start < 0 || len < 0) return "";

                var iEnd, iLen = String(str).length;
                if (start + len > iLen) {
                        iEnd = iLen;
                	return String(str).substring(start,iEnd);
                }
                else {
                        iEnd = start + len;
                	return String(str).substring(start,iEnd) + '...';
                }

        }

function parseRSS(rssXML) {
  try {
    netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
  }
  catch (e) {
    // this isn't netscape...
  }
  var a_p = "";
  var d = new Date();
  var curr_hour = d.getHours();
  if (curr_hour < 12) {
    a_p = "AM";
  }
  else {
    a_p = "PM";
  }
  if (curr_hour == 0) {
    curr_hour = 12;
  }
  if (curr_hour > 12) {
    curr_hour = curr_hour - 12;
  }

  var curr_min = d.getMinutes();
  var curr_day = d.getDay();

  curr_min = curr_min + "";

  if (curr_min.length == 1) {
    curr_min = "0" + curr_min;
  }

  var days = new Array();
  days[0] = "Sunday";
  days[1] = "Monday";
  days[2] = "Tuesday";
  days[3] = "Wednesday";
  days[4] = "Thursday";
  days[5] = "Friday";
  days[6] = "Saturday";

  end = 15;
  rssItems = rssXML.getElementsByTagName("item");
  rssTitle = null; 
  rssLink  = null;
  rssColor = null;
        
  if (end > rssItems.length) {
    end = rssItems.length;
  }
  document.getElementById("content").innerHTML = "Parsing...";

  myinnerHTML = "";
  for (i = 0; i < end; i++) {

    if (i > rssItems.length) {
    }
    else {
      rssTitle    = rssItems[i].getElementsByTagName('title')[0].childNodes[0].nodeValue;
      rssItem     = rssTitle;
      rssLink     = rssItems[i].getElementsByTagName("link")[0].childNodes[0].nodeValue;
      rssDescription = rssItems[i].getElementsByTagName("pubDate")[0].childNodes[0].nodeValue;
//      rssColor    = rssItems[i].getElementsByTagName("color")[0].childNodes[0].nodeValue;
     // rssBackground

      myinnerHTML = myinnerHTML.toString() + '<div class="row" title="' + rssDescription +'"><a class="' + rssColor + '" href="javascript:widget.openURL(\'' + rssLink + '\'); return true">' + Mid(rssItem,0,60) + '</a></div>';

    }
  }
        
  document.getElementById("content").style.visibility = "visible";
  document.getElementById("content").innerHTML = myinnerHTML;
  document.getElementById("status").innerHTML = 'Updated: ' + curr_hour + ':' + curr_min + ' ' + a_p;
  return 0;
        
}
